////////////////////////////////////////////////////////////////////////
/*! \file   Math/Math.h
 *  \brief  Common part to all Math includes.
 *  \author Jean-Dominique Gascuel
 *  \copyright ARTIS, Grenoble Universities, 2008.
 *
 * $Id: Math.h,v 1.3 2008/02/20 11:49:46 gascuel Exp $
 */
////////////////////////////////////////////////////////////////////////
// File History:

#ifndef MATH_H
#define MATH_H

#include <QtCore>               // Q_ASSERT
#include <math.h>               // sqrtf(), etc.
#include <float.h>              // FLT_EPSILON

// isnan is a #define on some linux implementation,
// which just kills isnan() function overloading...

#undef isnan
inline bool
isnan(float x)
{
    // A number is undefined when it is neither positiv nor negativ.
    return !(x<=0.0f || x>=0.0f) ; 
}

#ifndef M_PI
#define M_PI 3.1415926535f
#endif

#endif // MATH_H
