////////////////////////////////////////////////////////////////////////
/*! \file   OcclusionQuery.h
 *  \brief  Using OpenGL Occlusion Query to count fragment drawn.
 *  \author Jean-Dominique Gascuel
 *  \copyright ARTIS, Grenoble Universities, 2008.
 *
 * \sa Shader.
 */
////////////////////////////////////////////////////////////////////////
// $Id: OcclusionQuery.h,v 1.3 2008/02/20 11:49:45 gascuel Exp $
// File History:
// [jDG 2007/10/20] : Creation.


class OcclusionQuery
{
    unsigned int    _target;
    unsigned int    _id;
public:
    OcclusionQuery(int target = -1);
    ~OcclusionQuery();

    //! Launch the query.
    void start();

    //! End the query.
    void stop();

    //! Non-blocking function to know if the reasult is ready.
    bool isReady();

    //! block until result is ready, and return it.
    unsigned long count();
};