
/*  A Bison parser, made from scene_vrml.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse Scene_vrmlparse
#define yylex Scene_vrmllex
#define yyerror Scene_vrmlerror
#define yylval Scene_vrmllval
#define yychar Scene_vrmlchar
#define yydebug Scene_vrmldebug
#define yynerrs Scene_vrmlnerrs
#define	VRML_HEADER	257
#define	VRML_NAME	258
#define	VRML_VALUE	259
#define	VRML_STRING	260
#define	VRML_TRUE	261
#define	VRML_FALSE	262
#define	VRML_DEF	263
#define	VRML_USE	264
#define	VRML_SEPARATOR	265
#define	VRML_GROUP	266
#define	VRML_TRANSFORM	267
#define	VRML_TRANSLATION	268
#define	VRML_ROTATION	269
#define	VRML_SCALE	270
#define	VRML_SCALEORIENTATION	271
#define	VRML_CENTER	272
#define	VRML_CHILDREN	273
#define	VRML_SHAPE	274
#define	VRML_APPEARANCE	275
#define	VRML_GEOMETRY	276
#define	VRML_MATERIAL	277
#define	VRML_AMBIENTINTENSITY	278
#define	VRML_DIFFUSECOLOR	279
#define	VRML_SPECULARCOLOR	280
#define	VRML_TRANSPARENCY	281
#define	VRML_SHININESS	282
#define	VRML_COORDINATE	283
#define	VRML_POINT	284
#define	VRML_NORMALBINDING	285
#define	VRML_PER_VERTEX_INDEXED	286
#define	VRML_NORMAL	287
#define	VRML_VECTOR	288
#define	VRML_TEXCOORD	289
#define	VRML_TEXTURE	290
#define	VRML_IMAGE	291
#define	VRML_URL	292
#define	VRML_IFS	293
#define	VRML_CCW	294
#define	VRML_SOLID	295
#define	VRML_CONVEX	296
#define	VRML_COORD	297
#define	VRML_COORDINDEX	298
#define	VRML_NORMALPERVERTEX	299
#define	VRML_NORMALINDEX	300
#define	VRML_TEXCOORDINDEX	301
#define	VRML_BOX	302
#define	VRML_SIZE	303
#define	VRML_SPHERE	304
#define	VRML_RADIUS	305


////////////////////////////////////////////////////////////////////////
/*! \file      Scene_vrml.y
 *  \brief     Grammar to parse VRML files.
 *  \author    Jean-Dominique Gascuel
 *  \copyright ARTIS, Grenoble Universities, 2008.
 */
////////////////////////////////////////////////////////////////////////
// $Id: Scene_vrml_yacc.cpp,v 1.16 2008/02/20 11:49:45 gascuel Exp $

#include <stdlib.h>

#include <QVector>
#include <QStack>
#include <QFileInfo>
#include <QImage>
#include <QProgressDialog>
#include <QHash>

#include "Math/Vec4f.h"
#include "Math/Vec3f.h"
#include "Math/Vec2f.h"
#include "Math/Matrix4.h"
#include "Math/Quaternion.h"

#include "Scene.h"

#define YYERROR_VERBOSE 1

extern void  Scene_vrmlerror(const char *msg);
extern int   Scene_vrmllex();
extern char* Scene_vrmltext;
extern int   Scene_vrmlleng;
extern void  Scene_vrmlrestart(FILE*);

extern int Scene_vrml_version;
extern int Scene_vrml_lineno;
QString Scene_vrml_file;
int Scene_vrml_file_size = 0;
bool Scene_vrml_ok;
QProgressDialog *progress = 0;

static Matrix4 transform;
static Vec3f transformTranslation, transformScale, transformCenter;
static Quaternion transformRotation, transformScaleOrientation;
static void composeTransforms();
static QVector<float> floats;
static QVector<int>   ints;
static QVector<Vec2f> texCoord;
static QVector<int>   texIndices;
static QVector<Vec3f> coordinates;
static QVector<int>   coordIndices;
static QVector<Vec3f> normals;
static QVector<int>   normalIndices;
static QStack<Matrix4> transformStack;
static bool ccw = true,
            convex = false,
            solid = false,
            normalPerVertex = false;
static Vec3f size;            

#define YYPARSE_PARAM scene

// Minimal context to associate geometry, appearance, material, and texture.
static struct ShapeContext
{
    ScnObject *object;
    float      ambient;
    Vec4f      diffuse;
    Vec4f      specular;
    float      shininess;
    QImage     image;
    QString    imageFileName;
} shapeContext;

// Minimal storage to allow later sharing of a part of geometry.
// Because transformation stack is already applyed when storing
// the object, we should retain it to move any further instance(s).
struct Instance
{
    const ScnObject* o;       // Object to share.
    const Matrix4    xfm;     // It's location, to move it elsewhere afterward.
    
    Instance(const ScnObject* o, const Matrix4& xfm)
    : o(o), xfm(xfm)
    {}
};

// table to retain objects.
typedef QHash<QString, const Instance *> ObjectMap;
static ObjectMap objectMap;


typedef union {
    bool b;
    float f;
    int i;
    char* s;
    float vec3[3];
//  float vec4[4];
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		229
#define	YYFLAG		-32768
#define	YYNTBASE	56

#define YYTRANSLATE(x) ((unsigned)(x) <= 305 ? yytranslate[x] : 95)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    54,     2,    55,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    52,     2,    53,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     4,     6,    10,    11,    14,    16,    17,    20,
    22,    25,    26,    30,    31,    34,    36,    38,    40,    42,
    44,    46,    48,    50,    52,    54,    59,    60,    66,    71,
    72,    78,    79,    85,    91,    96,   101,   107,   112,   117,
   122,   127,   132,   137,   138,   141,   144,   147,   150,   153,
   155,   158,   162,   164,   166,   168,   170,   172,   174,   176,
   177,   181,   185,   190,   195,   199,   205,   208,   209,   214,
   219,   224,   229,   232,   237,   242,   243,   249,   253,   254,
   258,   262,   266,   270,   275,   281,   286,   290,   296,   301,
   305,   311,   314,   317,   318,   322,   325,   329,   333,   337,
   341,   342,   347,   351,   354,   357,   358,   363,   368,   371,
   374,   375,   379,   383,   387,   391,   395,   398
};

static const short yyrhs[] = {     7,
     0,     8,     0,     5,     0,    57,    57,    57,     0,     0,
    59,    57,     0,     5,     0,     0,    61,    60,     0,     4,
     0,     3,    64,     0,     0,    64,    65,    66,     0,     0,
     9,    62,     0,    67,     0,    70,     0,    72,     0,    73,
     0,    74,     0,    75,     0,    76,     0,    77,     0,    78,
     0,    79,     0,    62,    52,    80,    53,     0,     0,    11,
    68,    52,    64,    53,     0,    12,    52,    64,    53,     0,
     0,    13,    69,    52,    84,    53,     0,     0,    20,    52,
    71,    85,    53,     0,    35,    52,    30,    91,    53,     0,
    29,    52,    86,    53,     0,    31,    52,    89,    53,     0,
    33,    52,    34,    90,    53,     0,    36,    52,    92,    53,
     0,    48,    52,    87,    53,     0,    50,    52,    87,    53,
     0,    39,    52,    88,    53,     0,    21,    52,    93,    53,
     0,    23,    52,    94,    53,     0,     0,    80,    81,     0,
    80,     1,     0,    62,    82,     0,    10,    62,     0,    83,
    82,     0,    56,     0,    57,    59,     0,    54,    59,    55,
     0,    66,     0,     6,     0,    16,     0,    15,     0,    14,
     0,    18,     0,    17,     0,     0,    84,    14,    58,     0,
    84,    16,    58,     0,    84,    15,    58,    57,     0,    84,
    17,    58,    57,     0,    84,    18,    58,     0,    84,    19,
    54,    64,    55,     0,    84,     1,     0,     0,    85,    21,
    65,    78,     0,    85,    22,    65,    77,     0,    85,    22,
    10,    62,     0,    85,    36,    65,    76,     0,    85,     1,
     0,    30,    54,    59,    55,     0,    30,    54,     1,    55,
     0,     0,    87,    49,    57,    57,    57,     0,    87,    51,
    57,     0,     0,    88,    40,    56,     0,    88,    42,    56,
     0,    88,    41,    56,     0,    88,    45,    56,     0,    88,
    43,    65,    73,     0,    88,    44,    54,    61,    55,     0,
    88,    33,    65,    75,     0,    88,    33,    90,     0,    88,
    46,    54,    61,    55,     0,    88,    35,    65,    72,     0,
    88,    35,    91,     0,    88,    47,    54,    61,    55,     0,
    88,    81,     0,    88,     1,     0,     0,    89,     5,    32,
     0,    89,     1,     0,    54,    59,    55,     0,    54,     1,
    55,     0,    54,    59,    55,     0,    54,     1,    55,     0,
     0,    92,    37,    58,    61,     0,    92,    38,     6,     0,
    92,    81,     0,    92,     1,     0,     0,    93,    23,    65,
    79,     0,    93,    36,    65,    76,     0,    93,    81,     0,
    93,     1,     0,     0,    94,    24,    57,     0,    94,    25,
    58,     0,    94,    26,    58,     0,    94,    27,    57,     0,
    94,    28,    57,     0,    94,    81,     0,    94,     1,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   183,   184,   188,   189,   192,   193,   196,   203,   204,   207,
   215,   222,   223,   226,   230,   236,   238,   239,   240,   241,
   242,   243,   244,   245,   246,   247,   255,   260,   264,   266,
   271,   280,   291,   308,   311,   327,   330,   333,   336,   344,
   351,   446,   449,   456,   457,   458,   461,   468,   469,   472,
   474,   475,   476,   477,   481,   483,   484,   485,   486,   492,
   498,   503,   508,   513,   518,   523,   524,   528,   529,   530,
   535,   549,   550,   553,   555,   558,   560,   562,   566,   582,
   584,   586,   588,   590,   592,   596,   598,   600,   605,   607,
   608,   613,   614,   617,   618,   620,   623,   637,   640,   657,
   660,   661,   693,   699,   700,   703,   704,   705,   706,   707,
   710,   711,   715,   721,   727,   731,   735,   736
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","VRML_HEADER",
"VRML_NAME","VRML_VALUE","VRML_STRING","VRML_TRUE","VRML_FALSE","VRML_DEF","VRML_USE",
"VRML_SEPARATOR","VRML_GROUP","VRML_TRANSFORM","VRML_TRANSLATION","VRML_ROTATION",
"VRML_SCALE","VRML_SCALEORIENTATION","VRML_CENTER","VRML_CHILDREN","VRML_SHAPE",
"VRML_APPEARANCE","VRML_GEOMETRY","VRML_MATERIAL","VRML_AMBIENTINTENSITY","VRML_DIFFUSECOLOR",
"VRML_SPECULARCOLOR","VRML_TRANSPARENCY","VRML_SHININESS","VRML_COORDINATE",
"VRML_POINT","VRML_NORMALBINDING","VRML_PER_VERTEX_INDEXED","VRML_NORMAL","VRML_VECTOR",
"VRML_TEXCOORD","VRML_TEXTURE","VRML_IMAGE","VRML_URL","VRML_IFS","VRML_CCW",
"VRML_SOLID","VRML_CONVEX","VRML_COORD","VRML_COORDINDEX","VRML_NORMALPERVERTEX",
"VRML_NORMALINDEX","VRML_TEXCOORDINDEX","VRML_BOX","VRML_SIZE","VRML_SPHERE",
"VRML_RADIUS","'{'","'}'","'['","']'","bool","value","vec3","values","int","ints",
"name","file","nodes","def","node","group_node","@1","@2","shape_node","@3",
"texCoord_node","coordinate_node","hint_node","normal_node","texture_node","geometry_node",
"appearance_node","material_node","others","other","skiped_value","anyKeyword",
"transform_attributes","shape","point","geomParam","ifs","hints","normal","texCoord",
"image","appearance","material", NULL
};
#endif

static const short yyr1[] = {     0,
    56,    56,    57,    58,    59,    59,    60,    61,    61,    62,
    63,    64,    64,    65,    65,    66,    66,    66,    66,    66,
    66,    66,    66,    66,    66,    66,    68,    67,    67,    69,
    67,    71,    70,    72,    73,    74,    75,    76,    77,    77,
    77,    78,    79,    80,    80,    80,    81,    81,    81,    82,
    82,    82,    82,    82,    83,    83,    83,    83,    83,    84,
    84,    84,    84,    84,    84,    84,    84,    85,    85,    85,
    85,    85,    85,    86,    86,    87,    87,    87,    88,    88,
    88,    88,    88,    88,    88,    88,    88,    88,    88,    88,
    88,    88,    88,    89,    89,    89,    90,    90,    91,    91,
    92,    92,    92,    92,    92,    93,    93,    93,    93,    93,
    94,    94,    94,    94,    94,    94,    94,    94
};

static const short yyr2[] = {     0,
     1,     1,     1,     3,     0,     2,     1,     0,     2,     1,
     2,     0,     3,     0,     2,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     4,     0,     5,     4,     0,
     5,     0,     5,     5,     4,     4,     5,     4,     4,     4,
     4,     4,     4,     0,     2,     2,     2,     2,     2,     1,
     2,     3,     1,     1,     1,     1,     1,     1,     1,     0,
     3,     3,     4,     4,     3,     5,     2,     0,     4,     4,
     4,     4,     2,     4,     4,     0,     5,     3,     0,     3,
     3,     3,     3,     4,     5,     4,     3,     5,     4,     3,
     5,     2,     2,     0,     3,     2,     3,     3,     3,     3,
     0,     4,     3,     2,     2,     0,     4,     4,     2,     2,
     0,     3,     3,     3,     3,     3,     2,     2
};

static const short yydefact[] = {     0,
    12,    14,     0,     0,    10,    15,    27,     0,    30,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    13,    16,    17,    18,    19,    20,    21,    22,    23,
    24,    25,     0,    12,     0,    32,   106,   111,     0,    94,
     0,     0,   101,    79,    76,    76,    44,    12,    14,    60,
    68,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    14,    29,     0,     0,   110,     0,    57,
    56,    55,    59,    58,    14,    14,    42,     0,   109,     0,
   118,     0,     0,     0,     0,     0,    43,   117,     0,    35,
    96,     0,    36,     0,     0,     0,     0,   105,     0,     0,
    38,   104,    93,    14,    14,     0,     0,     0,    14,     0,
     0,     0,     0,    41,    92,     0,     0,    39,    40,    46,
    26,    45,    28,    67,     0,     0,     0,     0,     0,     0,
    31,    73,    14,    14,    14,    33,    48,     0,     0,     3,
    54,     1,     2,     5,    50,     5,    53,    47,    49,   112,
     0,   113,   114,   115,   116,     0,     0,    95,     0,     0,
    37,     0,     0,    34,     8,   103,     0,    87,     0,    90,
    80,    82,    81,     0,     8,    83,     8,     8,     0,    78,
    61,     0,    62,     0,    65,    12,     0,     0,     0,     0,
   107,   108,     0,    51,     0,    75,    74,     6,    98,    97,
   100,    99,   102,    86,    89,    84,     0,     0,     0,     0,
    63,    64,    14,    69,    71,    70,    72,    52,     4,     7,
     9,    85,    88,    91,    77,    66,     0,     0,     0
};

static const short yydefgoto[] = {   145,
   151,   152,   157,   221,   203,    78,   227,     2,     4,   147,
    23,    33,    35,    24,    51,    25,    26,    27,    28,    29,
    30,    31,    32,    63,    79,   148,    80,    66,    67,    55,
    61,    60,    56,    95,    97,    59,    52,    53
};

static const short yypact[] = {    20,
-32768,    93,    82,   255,-32768,-32768,-32768,    39,-32768,    49,
    56,    69,    74,    94,    98,   104,   110,   111,   112,   113,
   114,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   120,-32768,   122,-32768,-32768,-32768,   118,-32768,
    88,   145,-32768,-32768,-32768,-32768,-32768,-32768,    50,-32768,
-32768,   172,   143,    80,    37,    31,   123,   127,   196,    96,
   -29,    45,    36,    70,-32768,    11,    34,-32768,    82,-32768,
-32768,-32768,-32768,-32768,   115,   115,-32768,   215,-32768,   215,
-32768,   179,   179,   179,   179,   179,-32768,-32768,     3,-32768,
-32768,   159,-32768,     8,   139,    16,   140,-32768,   179,   188,
-32768,-32768,-32768,    38,    51,    54,    54,    54,   115,   144,
    54,   147,   148,-32768,-32768,   179,   179,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,   179,   179,   179,   179,   179,   149,
-32768,-32768,   115,    29,   115,-32768,-32768,   176,   168,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
   179,-32768,-32768,-32768,-32768,   150,    13,-32768,   152,    14,
-32768,   154,    40,-32768,-32768,-32768,   182,-32768,   181,-32768,
-32768,-32768,-32768,   189,-32768,-32768,-32768,-32768,   179,-32768,
-32768,   179,-32768,   179,-32768,-32768,   203,    82,    77,   168,
-32768,-32768,    44,   179,   179,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   212,-32768,-32768,-32768,    60,    62,    73,   179,
-32768,-32768,    25,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   229,   230,-32768
};

static const short yypgoto[] = {    72,
   -75,   171,   -63,-32768,   -45,    -3,-32768,   -32,   -61,   227,
-32768,-32768,-32768,-32768,-32768,    63,    65,-32768,    75,  -133,
    48,    53,   103,-32768,    92,   163,-32768,-32768,-32768,-32768,
   199,-32768,-32768,   153,   142,-32768,-32768,-32768
};


#define	YYLAST		305


static const short yytable[] = {     6,
    21,    49,   146,   156,   146,   192,   150,    -5,   159,   154,
   155,   124,    -5,   138,   139,    64,   162,   140,   140,   116,
    -5,   117,     1,   118,   125,   126,   127,   128,   129,   130,
   160,    91,   163,     3,   132,    92,   120,     3,   188,     5,
   179,   180,   167,   169,   140,    69,     3,   174,   140,    70,
    71,    72,    73,    74,   133,   134,   217,    -5,     3,     3,
   142,   143,    -5,   131,   220,   137,   220,   197,   200,   135,
    -5,   187,   189,   190,    21,   195,    21,   220,     3,   226,
   193,   198,   194,    93,   198,     5,   136,   198,   121,    90,
    34,    94,   -11,   116,   202,   117,   103,   119,   218,     5,
    36,     3,    65,   210,    96,    69,   211,    37,   212,    70,
    71,    72,    73,    74,   222,    18,   223,   198,   198,   219,
    38,    57,   123,     3,    19,    39,    20,   224,   104,   207,
   105,   208,   209,    89,   225,   106,   107,   108,   109,   110,
   111,   112,   113,    81,    88,    40,     5,    54,   114,    41,
   102,   115,    69,   213,   122,    42,    70,    71,    72,    73,
    74,    43,    44,    45,    46,    47,    82,    83,    84,    85,
    86,    48,    68,    50,    58,     5,    94,   171,   172,   173,
    96,    69,   176,   140,   215,    70,    71,    72,    73,    74,
   158,   161,   164,   166,    75,    87,    98,   175,    12,     5,
   177,   178,   186,    17,   196,    69,   199,    76,   201,    70,
    71,    72,    73,    74,    15,    16,   220,    13,     5,   140,
   141,   142,   143,    11,    77,     7,     8,     9,   228,   229,
    22,   205,    99,   100,    10,    11,   216,    12,   206,   214,
   191,   204,   149,    13,    62,    14,   170,    15,   101,    16,
    17,     0,     0,    18,   153,     0,   168,     0,     5,     0,
     0,     0,    19,     0,    20,     7,     8,     9,   144,   165,
     0,     0,     0,     0,    10,    11,     0,    12,     0,     0,
     0,     0,     0,    13,     0,    14,     0,    15,     0,    16,
    17,     0,     0,    18,     0,   181,   182,   183,   184,   185,
     0,     0,    19,     0,    20
};

static const short yycheck[] = {     3,
     4,    34,    78,     1,    80,   139,    82,     5,     1,    85,
    86,     1,     5,    75,    76,    48,     1,     5,     5,    49,
     5,    51,     3,    53,    14,    15,    16,    17,    18,    19,
    94,     1,    96,     9,     1,     5,     1,     9,    10,     4,
   116,   117,   104,   105,     5,    10,     9,   109,     5,    14,
    15,    16,    17,    18,    21,    22,   190,    55,     9,     9,
     7,     8,    55,    53,     5,    69,     5,    55,    55,    36,
    55,   133,   134,   135,    78,   151,    80,     5,     9,    55,
   144,   157,   146,    53,   160,     4,    53,   163,    53,    53,
    52,    54,     0,    49,    55,    51,     1,    53,    55,     4,
    52,     9,    53,   179,    54,    10,   182,    52,   184,    14,
    15,    16,    17,    18,    55,    39,    55,   193,   194,   195,
    52,    34,    53,     9,    48,    52,    50,    55,    33,   175,
    35,   177,   178,    54,   210,    40,    41,    42,    43,    44,
    45,    46,    47,     1,    53,    52,     4,    30,    53,    52,
    59,    60,    10,   186,    63,    52,    14,    15,    16,    17,
    18,    52,    52,    52,    52,    52,    24,    25,    26,    27,
    28,    52,     1,    52,    30,     4,    54,   106,   107,   108,
    54,    10,   111,     5,   188,    14,    15,    16,    17,    18,
    32,    53,    53,     6,    23,    53,     1,    54,    23,     4,
    54,    54,    54,    36,    55,    10,    55,    36,    55,    14,
    15,    16,    17,    18,    33,    35,     5,    29,     4,     5,
     6,     7,     8,    21,    53,    11,    12,    13,     0,     0,
     4,   169,    37,    38,    20,    21,   189,    23,   174,   187,
   138,   167,    80,    29,    46,    31,   105,    33,    53,    35,
    36,    -1,    -1,    39,    84,    -1,   104,    -1,     4,    -1,
    -1,    -1,    48,    -1,    50,    11,    12,    13,    54,    99,
    -1,    -1,    -1,    -1,    20,    21,    -1,    23,    -1,    -1,
    -1,    -1,    -1,    29,    -1,    31,    -1,    33,    -1,    35,
    36,    -1,    -1,    39,    -1,   125,   126,   127,   128,   129,
    -1,    -1,    48,    -1,    50
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */

/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif



/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
{ yyval.b=true; ;
    break;}
case 2:
{ yyval.b=false; ;
    break;}
case 3:
{ yyval.f = atof(Scene_vrmltext); ;
    break;}
case 4:
{ yyval.vec3[0] = yyvsp[-2].f; yyval.vec3[1] = yyvsp[-1].f; yyval.vec3[2] = yyvsp[0].f; ;
    break;}
case 6:
{ floats.append(yyvsp[0].f); ;
    break;}
case 7:
{   // Beware of hexadecimal interegs (in Texture images).
                            if( Scene_vrmltext[0]=='0' && Scene_vrmltext[1]=='x' )
                                yyval.i = QString(Scene_vrmltext+2).toInt(0, 16);
                            else
                                yyval.i = QString(Scene_vrmltext).toInt();
                        ;
    break;}
case 9:
{ ints.append(yyvsp[0].i); ;
    break;}
case 10:
{ yyval.s = _strdup(Scene_vrmltext); ;
    break;}
case 14:
{
            yyval.s = 0;
        ;
    break;}
case 15:
{
            yyval.s = yyvsp[0].s;
        ;
    break;}
case 26:
{
            qDebug( "%d: Skipping unsupported node type '%s'",
                    Scene_vrml_lineno, yyvsp[-3].s );
            free(yyvsp[-3].s);
        ;
    break;}
case 27:
{   // Push current transform in transform-stack
                transformStack.push(transform);
            ;
    break;}
case 28:
{   // Pop current transform from stack
                transform = transformStack.pop();
            ;
    break;}
case 29:
{;
    break;}
case 30:
{   // Push current transform in transform-stack,
                // so composeTransforms() can get it.
                transformStack.push(transform);
            ;
    break;}
case 31:
{   // pop back current transform
                if( Scene_vrml_version > 1 )
                    transform = transformStack.pop();
                else
                    transformStack.pop();
            ;
    break;}
case 32:
{
                shapeContext.object = 0;
                shapeContext.ambient  = 0.2f;
                shapeContext.diffuse  = Vec4f(0.8f, 0.8f, 0.8f, 1.0f);
                shapeContext.specular  = Vec4f(0,0,0,1);
                shapeContext.shininess  = 0.0;
                shapeContext.image  = QImage();
                shapeContext.imageFileName = QString::null;
            ;
    break;}
case 33:
{
                if( shapeContext.object )
                {
                    Vec4f ambient = shapeContext.ambient * shapeContext.diffuse;
                    shapeContext.object->setAmbientColor ( ambient._x, ambient._y, ambient._z, shapeContext.diffuse._w);
                    shapeContext.object->setDiffuseColor ( shapeContext.diffuse._x, shapeContext.diffuse._y, shapeContext.diffuse._z, shapeContext.diffuse._w);
                    shapeContext.object->setSpecularColor( shapeContext.specular._x, shapeContext.specular._y, shapeContext.specular._z, shapeContext.specular._w);
                    shapeContext.object->setColorShininess( shapeContext.shininess );
                    if( ! shapeContext.imageFileName.isEmpty() )
                        shapeContext.object->setTexture( shapeContext.imageFileName );
                        
                    shapeContext.object = 0;    // No one is allowed to color it afterward.
                }
            ;
    break;}
case 35:
{   // Set current coord3 vector
                if( floats.count()%3 )
                    yyerror("Wrong number of values in 3D coordinates");
                else
                {
                    int n = floats.count()/3;
                    coordinates.resize( n );
                    for(int i=0; i<n; ++i)
                        coordinates[i] = Vec3f(floats[3*i], floats[3*i+1], floats[3*i+2]);
                }
                floats.clear();
            ;
    break;}
case 39:
{
                ScnObject *o = ((Scene*)scene)->makeBox( -0.5f * size, 0.5f * size);
                o->transform( transform );
                shapeContext.object = o;
            ;
    break;}
case 40:
{
                ScnObject *o = ((Scene*)scene)->makeSphere();
                o->transform( transform );
                shapeContext.object = o;
            ;
    break;}
case 41:
{   // Create faces from indices.
                ScnObject *o = new ScnObject;
                o->beginEdit();
                
                for(int i=0; i<coordIndices.count(); ++i)
                {
                    if( (i&127) == 0 )
                    {
                        progress->setLabelText(QString("Created %1 triangles")
                            .arg(o->indices.count()/3));
                    }

                    int len = 0;
                    while( (i<coordIndices.count()) && (coordIndices[i] != -1) )
                    {
                        int j = coordIndices[i];    // Index of the vertex
                        if( j > (int)coordinates.count() )
                            qWarning( "%d: Vertex index %d out of range [0..%d]",
                                      Scene_vrml_lineno,
                                      j, coordinates.count());
                        
                        int k=-1, l=-1;             // Indices for normals and texCoord.

                        // Get (optional) vertex normal:
                        if( normalPerVertex && normals.count() > 0 )
                            if( normalIndices.count() == coordIndices.count() )
                                k = normalIndices[i];
                            else
                                k = j;                            
                        if( k >= (int)normals.count() )
                            qWarning( "%d: Normal index %d out of range [0..%d])",
                                      Scene_vrml_lineno,
                                      k, normals.count());
                        
                        // Get (optional) vertex 2D texture coord:
                        if( texCoord.count() > 0 )
                            if( texIndices.count() == coordIndices.count() )
                                l = texIndices[i];
                            else
                                l = j;
                        if( l >= (int)texCoord.count() )
                            qWarning( "%d: Texture index %d out of range [0..%d]",
                                      Scene_vrml_lineno,
                                      l, texCoord.count());
                                
                        // Apply current transform to the vertex.
                        Vec3f v = transform.coordinatesOf(coordinates[j]);
 
                        if( k<0 )
                        {
                            if( l<0 )
                                o->insertFaceVertex( o->mergeVertex(v) );
                            else
                                o->insertFaceVertex( o->mergeVertex(v, *((Vec3f*)0), texCoord[l]) );
                        }
                        else
                        {
                            Vec3f n = transform.transformOf(normals[k]);

                            if( l<0 )
                                o->insertFaceVertex( o->mergeVertex(v, n) );
                            else
                                o->insertFaceVertex( o->mergeVertex(v, n, texCoord[l]) );
                        }
                        
                        ++len;
                        ++i;
                    }
                    o->insertFace(len);
                }
                o->endEdit();
                o->makeNormals();       // Generate all normals. This make a global smooth group for the object !
                o->checkNormals();
                o->setCulling( solid ? ccw ? Environment::BACK_FACE : Environment::FRONT_FACE : Environment::NO_CULLING );

                qWarning( "Found %d vertices, %d triangles",
                    o->vertices.count(),
                    o->indices.count()/3);
                
                if( Scene_vrml_version > 1 )
                {
                    coordinates.clear();
                    coordIndices.clear();
                    normals.clear();
                    normalIndices.clear();
                    texCoord.clear();
                    texIndices.clear();
                }
                
                shapeContext.object = o;    // Keep pointer to enable Shape to apply color onto it.
                ((Scene*)scene)->objects.push_back(o);
            ;
    break;}
case 47:
{
                qDebug( "%d: Skipping unsupported '%s' attribute",
                        Scene_vrml_lineno, yyvsp[-1].s);
                free(yyvsp[-1].s);
            ;
    break;}
case 50:
{;
    break;}
case 51:
{ floats.clear(); ;
    break;}
case 52:
{ floats.clear(); ;
    break;}
case 53:
{;
    break;}
case 60:
{
            transformCenter = transformTranslation = Vec3f(0,0,0);
            transformScale = Vec3f(1,1,1);
            transformScaleOrientation = transformRotation = Quaternion();
        ;
    break;}
case 61:
{   
            transformTranslation = Vec3f(yyvsp[0].vec3[0], yyvsp[0].vec3[1], yyvsp[0].vec3[2]);
            composeTransforms();
        ;
    break;}
case 62:
{
            transformScale = Vec3f(yyvsp[0].vec3[0], yyvsp[0].vec3[1], yyvsp[0].vec3[2]);
            composeTransforms();
        ;
    break;}
case 63:
{
            transformRotation = Quaternion( Vec3f(yyvsp[-1].vec3[0], yyvsp[-1].vec3[1], yyvsp[-1].vec3[2]), yyvsp[0].f);
            composeTransforms();
        ;
    break;}
case 64:
{
            transformScaleOrientation = Quaternion( Vec3f(yyvsp[-1].vec3[0], yyvsp[-1].vec3[1], yyvsp[-1].vec3[2]), yyvsp[0].f);
            composeTransforms();
        ;
    break;}
case 65:
{
            transformCenter = Vec3f(yyvsp[0].vec3[0], yyvsp[0].vec3[1], yyvsp[0].vec3[2]);
            composeTransforms();
        ;
    break;}
case 70:
{
            if( yyvsp[-1].s )
                objectMap.insert(yyvsp[-1].s, new Instance(shapeContext.object, transform) );
        ;
    break;}
case 71:
{
            if( const Instance *i = objectMap[yyvsp[0].s] )
            {
                // Compose transform to place the instance at its new position :
                Matrix4 xfm = i->xfm.inverse() * transform;
                shapeContext.object = i->o->copy();     // Keep source unchanged.
                shapeContext.object->transform(xfm);    // Move geometry.
                // Note: appearance are applyed later, so that's all for now.
            }
            else
                qDebug("%d: Skipping unknown reference to '%s'",
                    Scene_vrml_lineno, yyvsp[0].s);
        ;
    break;}
case 76:
{   size = Vec3f(1,1,1); ;
    break;}
case 77:
{   size = Vec3f(yyvsp[-2].f, yyvsp[-1].f, yyvsp[0].f); ;
    break;}
case 78:
{   size = Vec3f(yyvsp[0].f, yyvsp[0].f, yyvsp[0].f); ;
    break;}
case 79:
{   // Initialise state.
            if( Scene_vrml_version > 1 )
            {
                coordinates.clear();
                coordIndices.clear();
                normals.clear();
                normalIndices.clear();
                texCoord.clear();
                texIndices.clear();
                ccw = true;
                convex = false;
                solid = false;
                normalPerVertex = false;
            }
        ;
    break;}
case 80:
{   ccw = yyvsp[0].b; ;
    break;}
case 81:
{   convex = yyvsp[0].b; ;
    break;}
case 82:
{   solid = yyvsp[0].b; ;
    break;}
case 83:
{   normalPerVertex = yyvsp[0].b; ;
    break;}
case 84:
{;
    break;}
case 85:
{   coordIndices = ints;
            ints.clear();
        ;
    break;}
case 86:
{;
    break;}
case 87:
{;
    break;}
case 88:
{   // Set current normal indices
            normalIndices = ints;
            ints.clear();
        ;
    break;}
case 89:
{;
    break;}
case 91:
{   // Set current texture indices
            texIndices = ints;
            ints.clear();
        ;
    break;}
case 95:
{ normalPerVertex = true; ;
    break;}
case 97:
{   // Set current normals
            if( floats.count()%3 )
                yyerror("Wrong number of values in normales");
            else
            {
                int n = floats.count()/3;
                normals.resize( n );
                for(int i=0; i<n; ++i)
                    normals[i] = Vec3f(floats[3*i], floats[3*i+1], floats[3*i+2]);
            }
            floats.clear();
        ;
    break;}
case 99:
{   // Set current texCoord2 vector
                if( floats.count() %2 )
                    yyerror("Wrong number of points in 2D texture coordinates");
                else
                {
                    int n = floats.count()/2;
                    texCoord.resize( n );
                    for(int i=0; i<n; ++i)
                    {
                        // Revert Y-axis on texture coord, so image order matches OpenGL order.
                        texCoord[i] = Vec2f(floats[2*i], 1.0f - floats[2*i+1]);
                    }
                }
                floats.clear();
            ;
    break;}
case 102:
{
            int w = int(yyvsp[-1].vec3[0]), h = int(yyvsp[-1].vec3[1]), n = ints.count();
            if( n != w*h )
                yyerror("Wrong number of pixels in image.");
            shapeContext.image = QImage(w, h, (yyvsp[-1].vec3[2]==1) ? QImage::Format_RGB32  :
                                              (yyvsp[-1].vec3[2]==2) ? QImage::Format_ARGB32 :
                                              (yyvsp[-1].vec3[2]==3) ? QImage::Format_RGB32  :
                                                           QImage::Format_ARGB32 );
            int i=0;
            for(int y=0; y<h; ++y)
                for(int x=0; x<w; ++x)
                {
                    uint p = ints[i++];
                    switch( int(yyvsp[-1].vec3[2]) )
                    {
                    case 1:             // Gray as 0xgg
                        shapeContext.image.setPixel(x,y, qRgb(255&p, 255&p, 255&p) );
                        break;
                    case 2:             // Gray+Alpha as 0xggAA
                        shapeContext.image.setPixel(x,y, qRgba(255&(p>>8), 255&(p>>8), 255&(p>>8), 255&p) );
                        break;
                    case 3:             // RGB as 0xRRGGBB
                        shapeContext.image.setPixel(x,y, qRgb((p>>16), 255&(p>>8), 255&p) );
                        break;
                    default:            // RGB as 0xRRGGBBAA
                        shapeContext.image.setPixel(x,y, qRgba((p>>24), 255&(p>>16), 255&(p>>8), 255&p) );
                        break;
                    }
                }
            ints.clear();
        ;
    break;}
case 103:
{
            QString fileName = QString::fromUtf8(Scene_vrmltext+1, Scene_vrmlleng-2);
            shapeContext.imageFileName = QDir( Scene_vrml_file.section('/', 0, -2))
                                        .absoluteFilePath(fileName);
        ;
    break;}
case 112:
{
            shapeContext.ambient=yyvsp[0].f
        ;
    break;}
case 113:
{
            shapeContext.diffuse._x = yyvsp[0].vec3[0];
            shapeContext.diffuse._y = yyvsp[0].vec3[1];
            shapeContext.diffuse._z = yyvsp[0].vec3[2];
        ;
    break;}
case 114:
{
            shapeContext.specular._x = yyvsp[0].vec3[0];
            shapeContext.specular._y = yyvsp[0].vec3[1];
            shapeContext.specular._z = yyvsp[0].vec3[2];
        ;
    break;}
case 115:
{
            shapeContext.diffuse._w = shapeContext.specular._w = (1.0f-yyvsp[0].f);
        ;
    break;}
case 116:
{
            shapeContext.shininess = yyvsp[0].f;
        ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */


  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}


//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

// Beware: The order of operations is independant of the file order.
// Hence, we have to store everything, to compute from scratch.
static void
composeTransforms()
{
    Matrix4& tos = transformStack.top();

    // From the VRML97 spec (AnnotatedVrmlRef/ch3-352.htm):
    // P_parent = T  C  R  SR  S  -SR  -C  P_child 
    transform = tos
              * Matrix4::translate(transformTranslation)
              * Matrix4::translate(transformCenter)
              * Matrix4::rotate(transformRotation)
              * Matrix4::rotate(transformScaleOrientation)
              * Matrix4::scale(transformScale)
              * Matrix4::rotate(transformScaleOrientation.inverse())
              * Matrix4::translate(-transformCenter)
              ;
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

void 
Scene_vrmlerror(const char *msg)
{
    qWarning( "While importing VRML object:\n%s(%d): %s\nnear '%s ...'",
              Scene_vrml_file.toLatin1().constData(),
              Scene_vrml_lineno,
              msg, Scene_vrmltext);
    Scene_vrml_ok = false;
}

bool
loadVRML(Scene *scene, const QString& fileName)
{
    FILE *f = fopen(fileName.toLocal8Bit(), "r");
    if( ! f )
    {
        qWarning( "Cannot open input file '%s'", fileName.toLatin1().data() );
        return false;
    }

    Scene_vrml_lineno = 1;
    Scene_vrml_file = fileName;
    Scene_vrml_file_size = QFileInfo(fileName).size();
    Scene_vrml_ok = true;
    Scene_vrmlrestart(f);
    progress = new QProgressDialog("Loading VRML object...", "Cancel", 0, Scene_vrml_file_size);
    
    yyparse(scene);
    
    delete progress; progress = 0;
    fclose(f);
    texCoord.clear();
    texIndices.clear();
    coordinates.clear();
    coordIndices.clear();
    normals.clear();
    normalIndices.clear();
    objectMap.clear();

    qWarning( "Loaded VRML surface '%s'", fileName.toLatin1().constData() );
    qWarning( "Total %d triangles", scene->triangles());

    return Scene_vrml_ok;
}
