////////////////////////////////////////////////////////////////////////
/*! \file   Utilities.cpp
 *  \brief  Various functions for TBender
 *  \author Jean-Dominique Gascuel
 *  \copyright ARTIS, Grenoble Universities, 2008.
 */
////////////////////////////////////////////////////////////////////////
// $Id: Utilities.h,v 1.4 2008/02/20 11:49:46 gascuel Exp $
// File History:
// [jDG 2007/04/13] : Creation.

//////////////////////////////////////////////////////////////////////////////

class QString;

namespace TBender
{
    //! Returns current time [sec], using a high-precision counter.
    double time();

    //! Returns nice printout of seconds, from hours to nano-seconds.
    QString  timeCString(double t);

    //! Check (and report) any pending OpenGL error.
    void checkGLError(const char *file, int line, const char *what);
};

//////////////////////////////////////////////////////////////////////////////

#if defined(DEBUG)
#  define CHECK_GL_ERROR(what) TBender::checkGLError(__FILE__, __LINE__, what)
#else // NOT DEBUG
// Make sure CHECK_GL_ERROR do the same thing inside an if/else in DEBUG and
// release mode:
#  define CHECK_GL_ERROR(what)
#endif // DEBUG

