# $Id: qglviewer.pri,v 1.20 2007/12/08 14:34:31 gascuel Exp $

# Not in the command line : look in the environment :
isEmpty(QGLVIEWER)         : QGLVIEWER=$$(QGLVIEWER)
isEmpty(QGLVIEWER_VERSION) : QGLVIEWER_VERSION=libQGLViewer-2.2.6

# Neither was defined : look for some standard places :
isEmpty(QGLVIEWER) {

    win32 {
        exists( C:/Librairies/libQGLViewer )          : QGLVIEWER=C:/Librairies/libQGLViewer
        exists( C:/Dev/libQGLViewer )                 : QGLVIEWER=C:/Dev/libQGLViewer
        exists( C:/Librairies/$${QGLVIEWER_VERSION} ) : QGLVIEWER=C:/Librairies/$${QGLVIEWER_VERSION}
        exists( C:/Dev/$${QGLVIEWER_VERSION} )        : QGLVIEWER=C:/Dev/$${QGLVIEWER_VERSION}
    }
    
    # Other default location for unix To be defined !
    unix {
        exists( /usr/include/QGLViewer )              : QGLVIEWER=/usr
    }
    
    # Or search for a haunt directory :
    exists( ../libQGLViewer )          : QGLVIEWER=../libQGLViewer
    exists( ../$${QGLVIEWER_VERSION} ) : QGLVIEWER=../$${QGLVIEWER_VERSION}
}    

# Make sure we got it :
!exists( $${QGLVIEWER}/include/QGLViewer/qglviewer.h ) : error( Unable to find QGLViewer includes. Please setup QGLVIEWER variable )

# Add stuff so compile does work :
CONFIG      *= thread
QT          *= xml

DEFINES     *= QGLVIEWER=1 QGLVIEWER_STATIC=1
INCLUDEPATH *= $${QGLVIEWER}/include
HEADERS     *= $${QGLVIEWER}/include/QGLViewer/qglviewer.h
##############################################################################

win32 {
    isEmpty(ARCH) {
        localPath = $$(PATH)
		
		contains( localPath, .*VC.[Bb][Ii][Nn].*           ) : ARCH = win32
		contains( localPath, .*VC7.[Bb][Ii][Nn].*          ) : ARCH = win32
		contains( localPath, .*VC6.[Bb][Ii][Nn].*          ) : ARCH = win32
		
		contains( localPath, .*VC.[Bb][Ii][Nn].amd64.*     ) : ARCH = win64
		contains( localPath, .*VC.[Bb][Ii][Nn].x86_amd64.* ) : ARCH = win64
    }
    isEmpty(ARCH): ARCH = win32

    myLib = $${QGLVIEWER}/lib/
    exists( $$myLib/$$ARCH ) : myLib = $${myLib}$$ARCH/
    *msvc2005: exists( $$myLib/msvc2005 ) : myLib = $${myLib}msvc2005/
    exists( $$myLib/Qt4/     ) : myLib = $${myLib}Qt4/

    CONFIG(debug, debug|release) {
        exists( $$myLib/Debug/   )         : myLib = $${myLib}Debug/
    	exists( $$myLib/dQGLViewer.lib   ) : myLib = $${myLib}dQGLViewer
    } else {
        exists( $$myLib/Release/ ) : myLib = $${myLib}Release/
        exists( $$myLib/QGLViewer.lib    ) : myLib = $${myLib}QGLViewer
    }
    exists( $$myLib/QGLViewer225.lib ) : myLib = $${myLib}QGLViewer225
    exists( $$myLib/QGLViewer2.lib   ) : myLib = $${myLib}QGLViewer2
	

    # Just make sure we don't check directory's existance...
    myLib = $${myLib}.lib
}
unix {
    *64:  myLib = $${QGLVIEWER}/lib64/libQGLViewer.a
    !*64: myLib = $${QGLVIEWER}/lib/libQGLViewer.a
}

!exists( $$myLib ) : error( Unable to find $$myLib )

LIBS *= "$${myLib}"
